package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.PluginConfigDto;
import com.yice.webadmin.app.model.PluginConfig;
import com.yice.webadmin.app.service.PluginConfigService;
import com.yice.webadmin.app.vo.PluginConfigVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 插件编排配置管理操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "插件编排配置管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/pluginConfig")
public class PluginConfigController {

    @Autowired
    private PluginConfigService pluginConfigService;

    /**
     * 新增知识图谱管理数据。
     *
     * @param pluginConfigDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"pluginConfigDto.configId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody PluginConfigDto pluginConfigDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(pluginConfigDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PluginConfig pluginConfig = MyModelUtil.copyTo(pluginConfigDto, PluginConfig.class);
        pluginConfig = pluginConfigService.saveNew(pluginConfig);
        return ResponseResult.success(pluginConfig.getConfigId());
    }

    /**
     * 更新知识图谱管理数据。
     *
     * @param pluginConfigDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody PluginConfigDto pluginConfigDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(pluginConfigDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PluginConfig pluginConfig = MyModelUtil.copyTo(pluginConfigDto, PluginConfig.class);
        PluginConfig originalPluginConfig = pluginConfigService.getById(pluginConfig.getConfigId());
        if (originalPluginConfig == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!pluginConfigService.update(pluginConfig, originalPluginConfig)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除知识图谱管理数据。
     *
     * @param configId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long configId) {
        if (MyCommonUtil.existBlankArgument(configId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(configId);
    }

    /**
     * 批量删除知识图谱管理数据。
     *
     * @param configIdList 待删除对象的主键Id列表。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE_BATCH)
    @PostMapping("/deleteBatch")
    public ResponseResult<Void> deleteBatch(@MyRequestBody List<Long> configIdList) {
        if (MyCommonUtil.existBlankArgument(configIdList)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        for (Long configId : configIdList) {
            ResponseResult<Void> responseResult = this.doDelete(configId);
            if (!responseResult.isSuccess()) {
                return responseResult;
            }
        }
        return ResponseResult.success();
    }

    /**
     * 列出符合过滤条件的知识图谱管理列表。
     *
     * @param pluginConfigDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<PluginConfigVo>> list(
            @MyRequestBody PluginConfigDto pluginConfigDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        PluginConfig pluginConfigFilter = MyModelUtil.copyTo(pluginConfigDtoFilter, PluginConfig.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, PluginConfig.class);
        List<PluginConfig> pluginConfigList =
                pluginConfigService.getPluginConfigListWithRelation(pluginConfigFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(pluginConfigList, PluginConfig.INSTANCE));
    }

    /**
     * 查看指定知识图谱管理对象详情。
     *
     * @param configId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<PluginConfigVo> view(@RequestParam Long configId) {
        PluginConfig pluginConfig = pluginConfigService.getByIdWithRelation(configId, MyRelationParam.full());
        if (pluginConfig == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        PluginConfigVo pluginConfigVo = MyModelUtil.copyTo(pluginConfig, PluginConfigVo.class);
        return ResponseResult.success(pluginConfigVo);
    }

    private ResponseResult<Void> doDelete(Long configId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        PluginConfig originalPluginConfig = pluginConfigService.getById(configId);
        if (originalPluginConfig == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!pluginConfigService.remove(configId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
